function [ filtered_nemo_data ] = delete_profile( p_nemo_data, p_float_serial, p_profile_number )
%DELETE_PROFILE Deletes the given profile from the given float.
%   
%   Parameters:
%   p_nemo_data         Nemo data, loaded by nemo.load.data().
%   p_float_number      Input float serial number.
%   p_profile_number    Profile to be deleted.
%
%   Returns:
%   filtered_nemo_data	Nemo data with deleted profile.
%
%
% TODO: SECURITY CHECKS MISSING

% search float
float_count = length(p_nemo_data);
current_float = 1;
while current_float <= float_count
    current_serial = ...
        p_nemo_data{current_float}{1}.FLOAT_IDENTIFICATION.float_serial_number;
    if current_serial == p_float_serial
        break
    else
        current_float = current_float + 1;
    end
end

if current_float > float_count
    filtered_nemo_data = p_nemo_data;
    disp([mfilename ': Float could not be found in data, skipping...']);
    return
end

% found the right float, now find the profile
profile_count = length(p_nemo_data{current_float});
current_profile = 1;
while current_profile <= profile_count
    current_profile_number = ...
        p_nemo_data{current_float}{current_profile}.PROFILE_TECHNICAL_DATA.xmit_profile_number;
    if current_profile_number == p_profile_number
        break
    else
        current_profile = current_profile + 1;
    end
end

if current_profile > profile_count
    filtered_nemo_data = p_nemo_data;
    disp([mfilename ': Profile could not be found in data, skipping...']);
    return
end

filtered_nemo_data = p_nemo_data;
if current_profile == profile_count
    filtered_float = p_nemo_data{current_float}(1:end-1);
elseif current_profile == 1
    filtered_float = p_nemo_data{current_float}(2:end);
else
    filtered_float = {};
    filtered_float{1:current_profile-1} = ...
        p_nemo_data{current_float}(1:current_profile-1);
    filtered_float{current_profile+1:end} = ...
        p_nemo_data{current_float}(current_profile+1:end);
end
filtered_nemo_data{current_float} = filtered_float;

end

